<?php

error_reporting(E_ALL);
ini_set('display_errors', 'On');

function GET($url, $referer = null) {
	
	static $ch = null;
	
	if (is_null($ch)) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
		$cookie_path = ( strpos(PHP_OS, 'WIN') !== false ) ? 'NUL' : '/dev/null';
		curl_setopt($ch, CURLOPT_COOKIEJAR, $cookie_path); 
		curl_setopt($ch, CURLOPT_COOKIEFILE, $cookie_path);
		curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko');
	}
	
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_REFERER, $referer);
	
	return curl_exec($ch);
}

function wtcscrape($START) {

	for(;;) {

		$matches = [];

		$page = GET($START);

		preg_match('~episode_no=(\\d+)~', $START, $matches);

		$episode_no = $matches[1];

		preg_match('~<title>.+?\\| ([^<]+)</title>~ms', $page, $matches);

		$show_title = $matches[1];

		echo "${show_title} - ${episode_no}\n";
		
		if (preg_match('~<a href="([^"]+)" title="Next Episode"~ms', $page, $matches)) {
			$next_page = $matches[1];	
		} else {
			$next_page = null;
		}

		preg_match('~<div [^>]+ id="_imageList">(.+?)</div>~ms', $page, $matches);

		$inner_area = $matches[1];

		preg_match_all('~data-url="([^"]+)"~', $inner_area, $matches);

		$images = [];
		$max_width = 0;
		$full_height = 0;

		foreach($matches[1] as $i => $image_url) {
			
			echo "- Downloading image ".($i+1).' / '.(count($matches[1]))."...";
			
			$image = GET($image_url, $START);
			
			list($width, $height) = getimagesizefromstring($image);
			
			$max_width = max($max_width, $width);
			$full_height += $height;
			
			echo " ".strlen($image)." bytes\n";
			
			$images[] = $image;
			
		}

		$target = imagecreatetruecolor($max_width, $full_height);

		$running_height = 0;

		foreach($images as $image) {
			
			$ih = imagecreatefromstring($image);
			
			list($width, $height) = getimagesizefromstring($image);
			
			imagecopy($target, $ih, 0, $running_height, 0, 0, $width, $height); 
			
			imagedestroy($ih);
			
			$running_height += $height;
			
		}

		$filename = preg_replace('~[^a-zA-Z0-9]~', '_', $show_title).'_'.sprintf("%03d", $episode_no).".jpg";

		imagejpeg($target, $filename, 90);

		imagedestroy($target);

		//
		
		if (is_null($next_page)) {
			break;
		} else {
			$START = $next_page; // continue
		}
	}

	echo "Done.\n";

}

function main(array $argv) {
	
	if (count($argv) !== 1) {
		echo "Usage: wtcget.php URL\n";
		return false;
		
	}
	
	if (stripos($argv[0], 'webtoons.com') !== false) {
		wtcscrape($argv[0]);
		return true;
		
	} else {
		echo "Malformed URL\n";
		return false;
		
	}
}

die(main(isset($_SERVER['argv']) ? array_slice($_SERVER['argv'], 1) : []) ? 0 : 1);
